﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TradingAPI.MT4Server;

namespace RealTimeQuotes
{
    class Program
    {
        static void Main(string[] args)
        {
            new Program().Run();
        }

        void Run()
        {
			QuoteClient qc = new QuoteClient(67611, "wx1yhpn", "demo.fxgerchik.com", 443);
            try
            {
                Console.WriteLine("Connecting...");
                qc.Connect();
                Console.WriteLine("Connected to server");
                qc.OnQuote += new QuoteEventHandler(qc_OnQuote);
                qc.Subscribe("EURUSD");
                Console.WriteLine("Press any key...");
                Console.ReadKey();
                qc.Disconnect();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                Console.WriteLine("Press any key...");
                Console.ReadKey();
            }
        }

        void qc_OnQuote(object sender, QuoteEventArgs args)
        {
            Console.WriteLine(args.Symbol + " " + args.Bid + " " + args.Ask);
        }

        void Run2()
        {
            try
            {
                Server[] slaves;
                MainServer primary = QuoteClient.LoadSrv(@"MetaQuotes-Demo.srv", out slaves);
                QuoteClient qc = Connect(primary, slaves, 55967934, "ov2osqv");
                Console.WriteLine("Connected to server");
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            Console.WriteLine("Press any key...");
            Console.ReadKey();
        }

        QuoteClient Connect(MainServer primary, Server[] slaves, int user, string password)
        {
            Console.WriteLine("Connecting...");
            QuoteClient qc = new QuoteClient(user, password, primary.Host, primary.Port);
			try
            {
                qc.Connect();
                return qc;
            }
            catch (Exception)
            {
                Console.WriteLine("Cannot connect to main server");
                return ConnectSlaves(slaves, user, password);
            }
        }

        QuoteClient ConnectSlaves(Server[] slaves, int user, string password)
        {
            Console.WriteLine("Connecting to slaves...");
            foreach (var server in slaves)
            {
                QuoteClient qc = new QuoteClient(user, password, server.Host, server.Port);
				try
                {
                    qc.Connect();
                    return qc;
                }
                catch (Exception)
                {
                }
            }
            throw new Exception("Cannot connect to slaves");
        }
    }
}
